# Lattice Boltzmann-Method with Pystencils and lbmweights
Implementation of the Lattice Boltzmann Method with and without code generation.
Part of my bachelor's thesis "Code Generation for Lattice-Boltzmann Methods with Large
Neighbourhoods".
Developed for Ubuntu 18.04 and Python3.6

## Installation

    $ git clone this repository
    $ cd lbm-bigger-stencils
    $ virtualenv env
    $ source env/bin/activate
    $ pip3 install -r requirements.txt 
    
Install [lbmweights](https://i10git.cs.fau.de/ed52egek/lbmweights)

    $ git clone git@i10git.cs.fau.de:ed52egek/lbmweights.git
    $ pip3 install ./lbmweights
    
## Execution:
    $ python3 cli.py

Hit space to start the simulation. Hit space again to stop it. 

## Visualisation: 

Almost all the visualisations created throughout the thesis are located inside the 
visualise.py file.

    $ python3 visualise.py

To see old visualisation change the function called in the main method of visualise and
choose the function that is supposed to get called. The hash inside each function 
shows when the version of this repository when they were created. Sometimes 
the version has to be changed using:

    $ git checkout <hash>


## LBM with one Kernel
The implementation of the LBM using one single Kernel, as described in Chapter 3.4 Performance 
Benchmarks is located in lbmps.