from largelbm.lbmps import LbmPs
import matplotlib.pyplot as plt


def accuracy():
    sizes = [2*128]
    lattices = ["D2Q9", "D2V17",]
    times = []
    lbms = []
    for lattice_name in lattices:
        time_by_lattice = []
        for size in sizes:
            print("{} Starting size: {}".format(lattice_name, size))
            lbm = LbmPs(lattice_name, viscocity=1/6, resolution=size, iterations=1000, u_0=0.04, calc_error=True)
            t = lbm.run_lbm()
            lbms.append(lbm)
            time_by_lattice.append(t)
        times.append(time_by_lattice)
    print(times)

    plt.plot(lbms[0].times, lbms[0].errors, color="purple", label="D2Q9")
    plt.plot(lbms[1].times, lbms[1].errors, color="b", label="D2V17")
    #plt.plot(lbms[2].times, lbms[2].errors, color="cyan", label="D2V37")
    plt.legend()
    plt.show()


if __name__ == "__main__":
    accuracy()
