"""
WARNING: This Code is deprecated and based on the knowledge from my first V17 implementation. Can be ignored
"""


"""Automatically get all the Code changes needed if you switch up the weights or c_x, c_y
"""
from sympy import *
import numpy as np


weights = 1 / 36 * np.array([1, 4, 1, 4, 16, 4, 1, 4, 1], dtype=np.float32)
c_x = np.array([-1, 0, 1, -1, 0, 1, -1, 0, 1])
c_y = np.array([1, 1, 1, 0, 0, 0, -1, -1, -1])
"""
weights = np.zeros((17,), dtype=np.float32)
weights[0] = 0.402005
weights[1:5] = 0.116155
weights[5:9] = 0.0330064
weights[9:13] = 0.0000790786
weights[13:17] = 0.000258415

c_x = [0, 0, -1, 1, 0, -1, 1, -1, 1, -2, 2, -2, 2, 0, -3, 3, 0]
c_y = [0, 1, 0, 0, -1, 1, 1, -1, -1, 2, 2, -2, -2, 3, 0, 0, -3]
"""


def calc_feq(weights, c_x, c_y, cssquared):
    """
    :param weights: Weights of each discrete velocity
    :param c_x: x value of velocity set
    :param c_y: y value of velocity set
    :param cssquared: Equivalent to the Speed of sound in our simulation
    :return:
    """
    assert (
        len(weights) == len(c_x) == len(c_y)
    ), "Input dimensions of weights, c_x and c_y do not match"

    wi, roh, c_xi, c_yi, css, u_x, u_y, u_sq, u_x_sq, u_y_sq = symbols(
        "wi roh c_xi c_yi css u_x u_y u_sq u_x_sq u_y_sq"
    )

    def f_eq(c_xi_val, c_yi_val, cssquared):
        expr = (
            1
            + (u_x * c_xi + u_y * c_yi) / css
            + (u_x * c_xi + u_y * c_yi) ** 2 / (2 * css ** 2)
            - u_sq / (2 * css)
        )
        if cssquared == 1 / 3:
            expr = (
                1
                + 3 * (u_x * c_xi + u_y * c_yi)
                + 4.5
                * (
                    u_x_sq * c_xi ** 2
                    + 2 * u_x * c_xi * u_y * c_yi
                    + u_y_sq * c_yi ** 2
                )
                - 1.5 * u_sq
            )
        return expr.subs([(c_xi, c_xi_val), (c_yi, c_yi_val), (css, cssquared)])

    """ Tested for Q9 and the following f_eq entries:
    Not perfect whatsoever. Should be double checked and optimized to not do the same calculations repeatedly
    
    calc8 = roh * weights[8] * f_eq(c_xi_val=c_x[8], c_yi_val=c_y[8], cssquared=1/3)
    solution8 = roh/36 * (1 + 3*(u_x - u_y) - 9*u_x*u_y + 3*u_sq)
    calc4 = roh * weights[4] * f_eq(c_xi_val=c_x[4], c_yi_val=c_y[4], cssquared=1/3)
    solution4 = roh/18 * (2 - 6 * u_y + 9 * u_y_sq - 3*u_sq)
    calc = roh * weights[0] * f_eq(c_xi_val=c_x[0], c_yi_val=c_y[0], cssquared=1/3)
    solution = 2 * roh / 9 * (2 - 3 * u_sq)
    assert simplify(calc - solution) == 0
    assert simplify(calc4 - solution4) == 0
    print(simplify(calc8 - solution8))
    assert simplify(calc8 - solution8) == 0
    """
    for i in range(len(weights)):
        # u_xsq, u_ysq, u_xu_y, u_sq= symbols('u_x_sq u_y_sq u_x_u_y u_sq')
        feq = expand(f_eq(c_xi_val=c_x[i], c_yi_val=c_y[i], cssquared=1 / 3))
        feq = roh * feq
        print("self.f_eq[:,:,{}] = self.weights[{}] * {}".format(i, i, feq))


def calc_velocity(c_x, c_y):
    """
    Get the code needed to calculate the velocities in x and y direction
    TODO: DO not add this to the final code. It is not optimized for readability, performance and reusability
    :param c_x:
    :param c_y:
    :return:
    """
    variable_fmt = "self.data[:, :, {}]"
    plusx = ""
    plusy = ""

    ret_cx = "return (("
    ret_cy = "return (("
    for i in range(len(weights)):
        cx = c_x[i]
        cy = c_y[i]
        if cx > 0:
            if cx > 1:
                ret_cx += plusx + str(cx) + " * " + variable_fmt.format(i)
            else:
                ret_cx += plusx + variable_fmt.format(i)
            plusx = " + "

        if cy > 0:
            if cy > 1:
                ret_cy += plusy + str(cy) + " * " + variable_fmt.format(i)
            else:
                ret_cy += plusy + variable_fmt.format(i)
            plusy = " + "

    plusx = ""
    plusy = ""
    ret_cx += ") - ("
    ret_cy += ") - ("

    for i in range(len(weights)):
        cx = c_x[i]
        cy = c_y[i]
        if cx < 0:
            cx = abs(cx)
            if cx > 1:
                ret_cx += plusx + str(cx) + " * " + variable_fmt.format(i)
            else:
                ret_cx += plusx + variable_fmt.format(i)
            plusx = " + "

        if cy < 0:
            cy = abs(cy)
            if cy > 1:
                ret_cy += plusy + str(cy) + " * " + variable_fmt.format(i)
            else:
                ret_cy += plusy + variable_fmt.format(i)
            plusy = " + "

    ret_cx += "))"
    ret_cy += "))"

    print(ret_cx)
    print(ret_cy)


print("---------- Paste this into calc_vel_x and calc_vel_y ----------")
calc_velocity(c_x, c_y)
print("---------- Paste this into update f equilibrium ----------")
calc_feq(weights, c_x, c_y, 1 / 3)
